/*入口地址*/
var host = "http://139.224.220.248:8048/xiaobang/";
//状态栏颜色
var bar_color="#fff";
mui.init({
	preloadLimit:3
});
mui.plusReady(function () {
	plus.navigator.setStatusBarBackground(bar_color);
	plus.navigator.setStatusBarStyle('dark'); 
});
/**
 * 处理表单焦点，添加class="blur"避免弹出输入框
 */
try{
	mui(document).on("tap",".blur",function () {
		document.activeElement.blur();
	});
}catch(e){}
mui.plusReady(function () {
	//地区选择
	jQuery('[data-area]').each(function () {
		var the=jQuery(this);
		var opts=the.attr("data-area")?the.attr("data-area"):"{}";
		opts=eval("(" +opts+ ")");
		this.addEventListener('tap', function() {
			var picker = new mui.PopPicker({
				layer: typeof(opts.layer)!="undefined"?opts.layer:3
			});
			picker.setData(opts.data);
			picker.show(function (res) {
				var retext=res[0].text;
				var reid=res[0].value;
				if (typeof(res[1].text)!="undefined") {
					retext+=','+res[1].text;
					reid+=','+res[1].value;
				}
				if (typeof(res[2].text)!="undefined") {
					retext+=','+res[2].text;
					reid+=','+res[2].value;
				}
				the.html(retext);
				jQuery('[name="'+opts.name+'"]').val(reid);
			});
		});
	});
});

/*数组扩展*/
//返回数组下标
Array.prototype.indexOf = function(val) {
	for (var i = 0; i < this.length; i++) {
		if (this[i] == val) {
			return i;
		}
	}
	return -1;
};
//删除指定数组元素，一个参数按值删除，两个参数按下标删除
function array_remove(arr, val) {
	var index = arr.indexOf(val);
	arr.splice(index, 1);
	return arr;
}
//in_array
function in_array(arr, search) {
	for (var i = 0; i < arr.length; i++) {
		if (arr[i].toString() == search) {
			return true;
		}
	}
	return false;
}
/*angular*/
try {
	// 创建moudle1
	myAngular = angular.module('app', []);
	//创建控制器
	myAngular.controller("myController", function($scope, $http) {});
	//解析html
	myAngular.filter('html', function($sce) {
		return function(text) {
			return $sce.trustAsHtml(text);
		}
	})
		//价格过滤器(保留两位小数)
	myAngular.filter('price', function() {
		return function(x) {
			var f_x = parseFloat(x);
			var f_x = Math.round(x * 100) / 100;
			var s_x = f_x.toString();
			var pos_decimal = s_x.indexOf('.');
			if (pos_decimal < 0) {
				pos_decimal = s_x.length;
				s_x += '.';
			}
			while (s_x.length <= pos_decimal + 2) {
				s_x += '0';
			}
			return s_x;
		}
	});


	//日期过滤器
	myAngular.filter('date', function() {
		return function(x) {
			x = x * 1000;
			var myDate = new Date(x);
			var Y = myDate.getFullYear();
			var m = myDate.getMonth() + 1;
			var d = myDate.getDate();
			var H = myDate.getHours();
			var i = myDate.getMinutes();
			var s = myDate.getSeconds();
			return arguments[1].replace('Y', Y).replace('m', m).replace('d', d).replace('H', H).replace('i', i).replace('s', s);

		}
	});

	// 页面加载完成后,再加载模块
	angular.element(document).ready(function() {
		jQuery(".ng_hide").removeClass('ng_hide');
		angular.bootstrap(jQuery('html'), ["app"]);
		scope = angular.element(jQuery("body")).scope();
	});
} catch (e) {}



/*
 * 数据请求地址
 * 参数一 模型控制器及方法，模型若省略则默认是Mobile
 * 参数二 附加参数
 * 示例 U('Admin/s', "&x=1&b=2")
 */
function U() {
	if (arguments[0].indexOf('http://')!=-1) {
		return arguments[0];
	}
	
	return host + arguments[0];
}

//载入动画
function wd_loading() {
	jQuery('body').prepend('<div id="spinner"><div class="bounce1"></div><div class="bounce2"></div><div class="bounce3"></div></div>');
}


//图片上传
var Upload = function() {
	var obj = new Object();
	obj.max = 0; //单次最多选择图片张数
	obj.maxMsg = ''; //超出选择数量提示信息
	obj.multiple = true; //是否支持多张上传
	obj.filter = "image"; //类型
	obj.quality = 80; //压缩质量
	obj.width = 1024; //压缩宽度
	obj.uploader = new Object(); //存储上传对象
	obj.uploadurl = 'http://upload.qiniu.com'; //服务器端地址
	obj.showarea = ".showimg"; //图片显示区域
	obj.input = "";
	obj.ids = new Array();
	obj.urls=new Array();
	obj.callback = function(data) {
		if (obj.multiple === false) {
			jQuery(obj.input).val(data.key);
		} else {
			obj.urls.push(data.key); 
			jQuery(obj.input).val(obj.urls.join(','));
		}
		if (obj.multiple == true) {
			jQuery("img[src='" + obj.files[obj.uploaded] + "']").attr('data-id', data.id).after('<i class="iconfont remove">&#xe62c;</i>').closest('li').find('.progress').remove();
		} else {
			jQuery("img[src='" + obj.files[obj.uploaded] + "']").attr('data-url', data.url).after('<i class="iconfont remove">&#xe62d;</i>').closest('li').find('.progress').remove();
		}

	};
	obj.callback_pick=function (files) {
		
	};
	obj.remove = function() {
		if (obj.multiple === true) {
			mui(document).on('tap', obj.showarea + " img", function() {
				var the = jQuery(this);
				var val = array_remove(obj.ids, the.attr('data-id'));
				jQuery(obj.input).val(val.join(','));
			})
		}
	};
	obj.galleryImgs = function() {
		plus.gallery.pick(function(e) {
			if (obj.multiple === true) {
				//限制单次选择图片张数
				if (e.files.length > obj.max && obj.max != 0) {
					alert(obj.maxMsg);
					return false;
				}
				obj.files = e.files;
			} else {
				obj.files = new Array();
				obj.files[0] = e;
			}
			obj.callback_pick(obj.files);
			obj.uploaded = 0;
			obj.zipUp(obj.files[0]);
		}, function(e) {
			mui.toast("取消选择图片"); 
		}, {
			filter: obj.filter,
			multiple: obj.multiple,
			system:false
		});
	};
	obj.cameraImgs = function() {
		var cmr = plus.camera.getCamera();
		cmr.captureImage(function(e) {
			obj.uploaded = 0;
			obj.files = new Object();
			plus.io.resolveLocalFileSystemURL(e, function(entry) {
				obj.files[obj.uploaded] = entry.toLocalURL();
//				var img = new Image();
//				img.src = obj.files[obj.uploaded];
//				if (obj.multiple === true) {
//					img.onload = function() {
//						jQuery(obj.showarea).find('li:last-child').before('<li><div><img src="' + obj.files[obj.uploaded] + '"><i class="progress">上传中..</i></div></li>');
//					}
//				} else {
//					img.onload = function() {
//						jQuery(obj.showarea).find('.btn_upload').html('<img src="' + obj.files[obj.uploaded] + '"><i class="progress">上传中..</i>');
//					}
//				}
				obj.zipUp(obj.files[obj.uploaded]);
			});
		}, function(e) {
			//mui.toast("很抱歉，获取失败 ");
		});
	};
	obj.zipUp = function(src) {
		if (plus.os.name == 'Android') {
			var dst = '_doc/temp/' + String(src).split('/').pop();
		} else {
			var dst = '_doc/' + String(src).split('/').pop();
		}
		var img = new Image();
		img.src = src;
		img.onload = function() {
			if (img.width > obj.width) {
				plus.zip.compressImage({
						src: src,
						quality: obj.quality,
						dst: dst,
						overwrite: true,
						width: obj.width + 'px'
					},
					function(data) {
						obj.upload(data.target);
					}
				);
			} else {
				obj.upload(src);
			}
		}
	};
	obj.upload = function(src) {
		//创建上传对象  
		var uploader = plus.uploader.createUpload(obj.uploadurl, {
				method: "POST",
				blocksize: 0
			},
			function(data, status) {
				plus.io.resolveLocalFileSystemURL(src, function(e) {
					obj.callback(JSON.parse(data.responseText));
					obj.uploaded++;
					if (obj.uploaded < obj.files.length) {
						obj.zipUp(obj.files[obj.uploaded]);
					}
				});
			}
		);
		//添加上传文件 
		uploader.addFile(src, {
			key: "file"
		});
		uploader.addData('token',obj.token);
		//监听上传进度
		uploader.addEventListener("statechanged", function() {
			jQuery("[data-img='"+obj.files[obj.uploaded]+"']").find('img').animate({
				opacity: 0
			}, 1000);
		}, false);
		uploader.start();
	};
	return obj;
}

/*提示信息*/
function wd_alert (obj) {
	jQuery('body').prepend('<div class="wd_alert"><span>'+obj.msg+'</span></div>');
	jQuery(document).on('tap','.wd_alert',function () {
		jQuery(this).remove();
	})
	setTimeout(function () {
		jQuery(".wd_alert").animate({opacity:0},1000,function () {
			jQuery(".wd_alert").remove();
		});
	},obj.timeout)
}


//支付
function pay (obj) {
	//本地测试地址
	//url='http://demo.dcloud.net.cn/payment/?payid=wxpay?total=0.01'
	//url='http://demo.dcloud.net.cn/payment/?payid=alipay?total=0.01'
	// 获取支付通道
	var pays = {};
	var w = null;
	plus.payment.getChannels(function(channels) {
		for (var i in channels) {
			var channel = channels[i];
			pays[channel.id] = channel;
		}
		if (w) {
			return;
		}
		w = plus.nativeUI.showWaiting();
		mui.ajax(obj.url, {
		    data: obj.data,
		    dataType: "text",
		    type: "post",
		    timeout: 10000,
		    success: function(data) {
		    	if (obj.id=='wxpay') {
		    		alert(data)
		    		data=JSON.parse(data);
		    	}
		    	w.close();
		    	plus.payment.request(pays[obj.id], data, function(result) {
		    		console.log(result);
					obj.callback(result);
				}, function(e) {
					alert(JSON.stringify(e));
					mui.toast("未支付");
				});
		    },
		    error: function(e) {
		    	w.close();
		       	
		    }
		});
	}, function(e) {
		
	});
}


function md5(string){
        function md5_RotateLeft(lValue, iShiftBits) {
                return (lValue<<iShiftBits) | (lValue>>>(32-iShiftBits));
        }
        function md5_AddUnsigned(lX,lY){
                var lX4,lY4,lX8,lY8,lResult;
                lX8 = (lX & 0x80000000);
                lY8 = (lY & 0x80000000);
                lX4 = (lX & 0x40000000);
                lY4 = (lY & 0x40000000);
                lResult = (lX & 0x3FFFFFFF)+(lY & 0x3FFFFFFF);
                if (lX4 & lY4) {
                        return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
                }
                if (lX4 | lY4) {
                        if (lResult & 0x40000000) {
                                return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
                        } else {
                                return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
                        }
                } else {
                        return (lResult ^ lX8 ^ lY8);
                }
        }         
        function md5_F(x,y,z){
                return (x & y) | ((~x) & z);
        }
        function md5_G(x,y,z){
                return (x & z) | (y & (~z));
        }
        function md5_H(x,y,z){
                return (x ^ y ^ z);
        }
        function md5_I(x,y,z){
                return (y ^ (x | (~z)));
        }
        function md5_FF(a,b,c,d,x,s,ac){
                a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_F(b, c, d), x), ac));
                return md5_AddUnsigned(md5_RotateLeft(a, s), b);
        }; 
        function md5_GG(a,b,c,d,x,s,ac){
                a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_G(b, c, d), x), ac));
                return md5_AddUnsigned(md5_RotateLeft(a, s), b);
        };
        function md5_HH(a,b,c,d,x,s,ac){
                a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_H(b, c, d), x), ac));
                return md5_AddUnsigned(md5_RotateLeft(a, s), b);
        }; 
        function md5_II(a,b,c,d,x,s,ac){
                a = md5_AddUnsigned(a, md5_AddUnsigned(md5_AddUnsigned(md5_I(b, c, d), x), ac));
                return md5_AddUnsigned(md5_RotateLeft(a, s), b);
        };
        function md5_ConvertToWordArray(string) {
                var lWordCount;
                var lMessageLength = string.length;
                var lNumberOfWords_temp1=lMessageLength + 8;
                var lNumberOfWords_temp2=(lNumberOfWords_temp1-(lNumberOfWords_temp1 % 64))/64;
                var lNumberOfWords = (lNumberOfWords_temp2+1)*16;
                var lWordArray=Array(lNumberOfWords-1);
                var lBytePosition = 0;
                var lByteCount = 0;
                while ( lByteCount < lMessageLength ) {
                        lWordCount = (lByteCount-(lByteCount % 4))/4;
                        lBytePosition = (lByteCount % 4)*8;
                        lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount)<<lBytePosition));
                        lByteCount++;
                }
                lWordCount = (lByteCount-(lByteCount % 4))/4;
                lBytePosition = (lByteCount % 4)*8;
                lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80<<lBytePosition);
                lWordArray[lNumberOfWords-2] = lMessageLength<<3;
                lWordArray[lNumberOfWords-1] = lMessageLength>>>29;
                return lWordArray;
        }; 
        function md5_WordToHex(lValue){
                var WordToHexValue="",WordToHexValue_temp="",lByte,lCount;
                for(lCount = 0;lCount<=3;lCount++){
                        lByte = (lValue>>>(lCount*8)) & 255;
                        WordToHexValue_temp = "0" + lByte.toString(16);
                        WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length-2,2);
                }
                return WordToHexValue;
        };
        function md5_Utf8Encode(string){
                string = string.replace(/\r\n/g,"\n");
                var utftext = ""; 
                for (var n = 0; n < string.length; n++) {
                        var c = string.charCodeAt(n); 
                        if (c < 128) {
                                utftext += String.fromCharCode(c);
                        }else if((c > 127) && (c < 2048)) {
                                utftext += String.fromCharCode((c >> 6) | 192);
                                utftext += String.fromCharCode((c & 63) | 128);
                        } else {
                                utftext += String.fromCharCode((c >> 12) | 224);
                                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                                utftext += String.fromCharCode((c & 63) | 128);
                        } 
                } 
                return utftext;
        }; 
        var x=Array();
        var k,AA,BB,CC,DD,a,b,c,d;
        var S11=7, S12=12, S13=17, S14=22;
        var S21=5, S22=9 , S23=14, S24=20;
        var S31=4, S32=11, S33=16, S34=23;
        var S41=6, S42=10, S43=15, S44=21;
        string = md5_Utf8Encode(string);
        x = md5_ConvertToWordArray(string); 
        a = 0x67452301; b = 0xEFCDAB89; c = 0x98BADCFE; d = 0x10325476; 
        for (k=0;k<x.length;k+=16) {
                AA=a; BB=b; CC=c; DD=d;
                a=md5_FF(a,b,c,d,x[k+0], S11,0xD76AA478);
                d=md5_FF(d,a,b,c,x[k+1], S12,0xE8C7B756);
                c=md5_FF(c,d,a,b,x[k+2], S13,0x242070DB);
                b=md5_FF(b,c,d,a,x[k+3], S14,0xC1BDCEEE);
                a=md5_FF(a,b,c,d,x[k+4], S11,0xF57C0FAF);
                d=md5_FF(d,a,b,c,x[k+5], S12,0x4787C62A);
                c=md5_FF(c,d,a,b,x[k+6], S13,0xA8304613);
                b=md5_FF(b,c,d,a,x[k+7], S14,0xFD469501);
                a=md5_FF(a,b,c,d,x[k+8], S11,0x698098D8);
                d=md5_FF(d,a,b,c,x[k+9], S12,0x8B44F7AF);
                c=md5_FF(c,d,a,b,x[k+10],S13,0xFFFF5BB1);
                b=md5_FF(b,c,d,a,x[k+11],S14,0x895CD7BE);
                a=md5_FF(a,b,c,d,x[k+12],S11,0x6B901122);
                d=md5_FF(d,a,b,c,x[k+13],S12,0xFD987193);
                c=md5_FF(c,d,a,b,x[k+14],S13,0xA679438E);
                b=md5_FF(b,c,d,a,x[k+15],S14,0x49B40821);
                a=md5_GG(a,b,c,d,x[k+1], S21,0xF61E2562);
                d=md5_GG(d,a,b,c,x[k+6], S22,0xC040B340);
                c=md5_GG(c,d,a,b,x[k+11],S23,0x265E5A51);
                b=md5_GG(b,c,d,a,x[k+0], S24,0xE9B6C7AA);
                a=md5_GG(a,b,c,d,x[k+5], S21,0xD62F105D);
                d=md5_GG(d,a,b,c,x[k+10],S22,0x2441453);
                c=md5_GG(c,d,a,b,x[k+15],S23,0xD8A1E681);
                b=md5_GG(b,c,d,a,x[k+4], S24,0xE7D3FBC8);
                a=md5_GG(a,b,c,d,x[k+9], S21,0x21E1CDE6);
                d=md5_GG(d,a,b,c,x[k+14],S22,0xC33707D6);
                c=md5_GG(c,d,a,b,x[k+3], S23,0xF4D50D87);
                b=md5_GG(b,c,d,a,x[k+8], S24,0x455A14ED);
                a=md5_GG(a,b,c,d,x[k+13],S21,0xA9E3E905);
                d=md5_GG(d,a,b,c,x[k+2], S22,0xFCEFA3F8);
                c=md5_GG(c,d,a,b,x[k+7], S23,0x676F02D9);
                b=md5_GG(b,c,d,a,x[k+12],S24,0x8D2A4C8A);
                a=md5_HH(a,b,c,d,x[k+5], S31,0xFFFA3942);
                d=md5_HH(d,a,b,c,x[k+8], S32,0x8771F681);
                c=md5_HH(c,d,a,b,x[k+11],S33,0x6D9D6122);
                b=md5_HH(b,c,d,a,x[k+14],S34,0xFDE5380C);
                a=md5_HH(a,b,c,d,x[k+1], S31,0xA4BEEA44);
                d=md5_HH(d,a,b,c,x[k+4], S32,0x4BDECFA9);
                c=md5_HH(c,d,a,b,x[k+7], S33,0xF6BB4B60);
                b=md5_HH(b,c,d,a,x[k+10],S34,0xBEBFBC70);
                a=md5_HH(a,b,c,d,x[k+13],S31,0x289B7EC6);
                d=md5_HH(d,a,b,c,x[k+0], S32,0xEAA127FA);
                c=md5_HH(c,d,a,b,x[k+3], S33,0xD4EF3085);
                b=md5_HH(b,c,d,a,x[k+6], S34,0x4881D05);
                a=md5_HH(a,b,c,d,x[k+9], S31,0xD9D4D039);
                d=md5_HH(d,a,b,c,x[k+12],S32,0xE6DB99E5);
                c=md5_HH(c,d,a,b,x[k+15],S33,0x1FA27CF8);
                b=md5_HH(b,c,d,a,x[k+2], S34,0xC4AC5665);
                a=md5_II(a,b,c,d,x[k+0], S41,0xF4292244);
                d=md5_II(d,a,b,c,x[k+7], S42,0x432AFF97);
                c=md5_II(c,d,a,b,x[k+14],S43,0xAB9423A7);
                b=md5_II(b,c,d,a,x[k+5], S44,0xFC93A039);
                a=md5_II(a,b,c,d,x[k+12],S41,0x655B59C3);
                d=md5_II(d,a,b,c,x[k+3], S42,0x8F0CCC92);
                c=md5_II(c,d,a,b,x[k+10],S43,0xFFEFF47D);
                b=md5_II(b,c,d,a,x[k+1], S44,0x85845DD1);
                a=md5_II(a,b,c,d,x[k+8], S41,0x6FA87E4F);
                d=md5_II(d,a,b,c,x[k+15],S42,0xFE2CE6E0);
                c=md5_II(c,d,a,b,x[k+6], S43,0xA3014314);
                b=md5_II(b,c,d,a,x[k+13],S44,0x4E0811A1);
                a=md5_II(a,b,c,d,x[k+4], S41,0xF7537E82);
                d=md5_II(d,a,b,c,x[k+11],S42,0xBD3AF235);
                c=md5_II(c,d,a,b,x[k+2], S43,0x2AD7D2BB);
                b=md5_II(b,c,d,a,x[k+9], S44,0xEB86D391);
                a=md5_AddUnsigned(a,AA);
                b=md5_AddUnsigned(b,BB);
                c=md5_AddUnsigned(c,CC);
                d=md5_AddUnsigned(d,DD);
        }
        return (md5_WordToHex(a)+md5_WordToHex(b)+md5_WordToHex(c)+md5_WordToHex(d)).toLowerCase();
}




//打开QQ
function open_qq(qq) {
	switch (plus.os.name){
		case 'Android':
			var main = plus.android.runtimeMainActivity();
        	var Intent = plus.android.importClass('android.content.Intent');
        	var Uri = plus.android.importClass('android.net.Uri');
       		var intent = new Intent(Intent.ACTION_VIEW, Uri.parse("mqqwpa://im/chat?chat_type=wpa&uin="+qq));
        	main.startActivity(intent);
			break;
		case 'iOS':
			plus.runtime.launchApplication({
	            action: "mqq://im/chat?chat_type=wpa&uin="+qq+"&version=1&src_type=web"
	        }, function(e) {
	            /*plus.nativeUI.confirm("检查到您未安装qq，请先到appstore搜索下载？", function(i) {
	                if (i.index == 0) {
	                    iosAppstore("itunes.apple.com/cn/app/mqq/");
	                }
	            });*/
	        });
		default:
			break;
	}
}



(function(win) {
	/**
 	* @author 1020450921@qq.com
 	* @link http://www.cnblogs.com/phillyx
 	* @link http://ask.dcloud.net.cn/people/%E5%B0%8F%E4%BA%91%E8%8F%9C
	* @description 本地存储
	*/
	var myStorage = {};

	function getItem(k) {
		var jsonStr = window.localStorage.getItem(k.toString());
		return jsonStr ? JSON.parse(jsonStr).data : '';
	};

	function getItemPlus(k) {
		var jsonStr = plus.storage.getItem(k.toString());
		return jsonStr ? JSON.parse(jsonStr).data : '';
	};
	myStorage.getItem = function(k) {
		return getItem(k) || getItemPlus(k);
	};
	myStorage.setItem = function(k, value) {
		value = JSON.stringify({
			data: value
		});
		k = k.toString();
		try {
			window.localStorage.setItem(k, value);
		} catch (e) {
			console.log(e);
			//TODO 超出localstorage容量限制则存到plus.storage中
			//且删除localStorage重复的数据
			removeItem(k);
			plus.storage.setItem(k, value);
		}
	};

	function getLength() {
		return window.localStorage.length;
	};
	myStorage.getLength = getLength;

	function getLengthPlus() {
		return plus.storage.getLength();
	};
	myStorage.getLengthPlus = getLengthPlus;

	function removeItem(k) {
		return window.localStorage.removeItem(k);
	};

	function removeItemPlus(k) {
		return plus.storage.removeItem(k);
	};
	myStorage.removeItem = function(k) {
		window.localStorage.removeItem(k);
		return plus.storage.removeItem(k);
	}
	myStorage.clear = function() {
		window.localStorage.clear();
		return plus.storage.clear();
	};

	function key(index) {
		return window.localStorage.key(index);
	};
	myStorage.key = key;

	function keyPlus(index) {
		return plus.storage.key(index);
	};
	myStorage.keyPlus = keyPlus;

	function getItemByIndex(index) {
		var item = {
			keyname: '',
			keyvalue: ''
		};
		item.keyname = key(index);
		item.keyvalue = getItem(item.keyname);
		return item;
	};
	myStorage.getItemByIndex = getItemByIndex;

	function getItemByIndexPlus(index) {
		var item = {
			keyname: '',
			keyvalue: ''
		};
		item.keyname = keyPlus(index);
		item.keyvalue = getItemPlus(item.keyname);
		return item;
	};
	myStorage.getItemByIndexPlus = getItemByIndexPlus;
	/**
	 * @author liuyf 2015-05-04
	 * @description 获取所有存储对象
	 * @param {Object} key 可选，不传参则返回所有对象，否则返回含有该key的对象
	 */
	myStorage.getItems = function(k) {
		var items = [];
		var numKeys = getLength();
		var numKeysPlus = getLengthPlus();
		var i = 0;
		if (k) {
			for (; i < numKeys; i++) {
				if (key(i).toString().indexOf(k) != -1) {
					items.push(getItemByIndex(i));
				}
			}
			for (i = 0; i < numKeysPlus; i++) {
				if (keyPlus(i).toString().indexOf(k) != -1) {
					items.push(getItemByIndexPlus(i));
				}
			}
		} else {
			for (i = 0; i < numKeys; i++) {
				items.push(getItemByIndex(i));
			}
			for (i = 0; i < numKeysPlus; i++) {
				items.push(getItemByIndexPlus(i));
			}
		}
		return items;
	};
	/**
	 * @description 清除指定前缀的存储对象
	 * @param {Object} keys
	 * @default ["filePathCache_","ajax_cache_"]
	 * @author liuyf 2015-07-21
	 */
	myStorage.removeItemByKeys = function(keys, cb) {
		if (typeof(keys) === "string") {
			keys = [keys];
		}
		var numKeys = getLength();
		var numKeysPlus = getLengthPlus();
		//TODO plus.storage是线性存储的，从后向前删除是可以的 
		//稳妥的方案是将查询到的items，存到临时数组中，再删除  
		var tmpks = [];
		var tk,
			i = numKeys - 1;
		for (; i >= 0; i--) {
			tk = key(i);
			Array.prototype.forEach.call(keys, function(k, index, arr) {
				if (tk.toString().indexOf(k) != -1) {
					tmpks.push(tk);
				}
			});
		}
		tmpks.forEach(function(k) {
			removeItem(k);
		});
		for (i = numKeysPlus - 1; i >= 0; i--) {
			tk = keyPlus(i);
			Array.prototype.forEach.call(keys, function(k, index, arr) {
				if (tk.toString().indexOf(k) != -1) {
					tmpks.push(tk);
				}
			});
		}
		tmpks.forEach(function(k) {
			removeItemPlus(k);
		})
		cb && cb();
	};
	win.myStorage = myStorage;
}(window));


/*新开窗口封装
 data-openwindow='{id:"show",title:"窗口标题",data:{infoid:{{v.goods_id}}}}'
 * */
mui(document).on("tap", "[data-openwindow]", function() {
	var the = jQuery(this);
	var opts = the.attr("data-openwindow");
	opts = eval("(" + opts + ")");
	opts.id=opts.id=='index'?plus.runtime.appid:opts.id;
	var url=typeof(opts.url)!="undefined"?opts.url:opts.id+'.html';
	var title=typeof(opts.title)!="undefined"?opts.title:false;
	var style=typeof(opts.style)!="undefined"?opts.style:{top:'0',bottom:'0',bounce:'none'};
	var animation=typeof(opts.animation)!="undefined"?opts.animation:'none';
	myStorage.setItem("forward",plus.webview.currentWebview().id);
	if (opts.login===true && !myStorage.getItem('uid')>0) {
		if (!plus.webview.getWebviewById('login')) {
			plus.webview.create('login.html','login');
		}else{
			plus.webview.hide(opts.id);
		}
		setTimeout(function () {
	    	plus.webview.show('login',animation);
		},200);
	}else{
		if (!plus.webview.getWebviewById(opts.id)) {
			if (title!==false) {
				style.titleNView = { 
					backgroundColor: bar_color, 
					titleText: title, 
					titleColor: '#fff', 
					type: 'default', 
					autoBackButton: true
				}
			}
			plus.webview.create(url,opts.id,style,opts.data);
			setTimeout(function () {
				mui.fire(plus.webview.getWebviewById(opts.id), opts.id,opts.data); 
			},50);
		}else{
			plus.webview.hide(opts.id);
			mui.fire(plus.webview.getWebviewById(opts.id), opts.id,opts.data); 
		}
		setTimeout(function () {
	    	plus.webview.show(opts.id,animation,300);
		},200);
	}
	
})



//js分页
//version 1.0.1
//示例
//list({
//	url:'{:U("index")}',
//	data:{
//		row: 20
//	},
//	callback:function (data) {
//		console.log(data.sql);
//		scope.list = data.data;
//		scope.totalPage = data.totalPage;
//		scope.$apply();
//		jQuery("#spinner").hide();
//		scrollTo(0,0);
//	},
//	callback_next:function (data) {
//		Array.prototype.push.apply(scope.list, data.data);
//	}
//}); 
function list() {
	var opts = arguments[0];
	scope.p = typeof(opts.data.p) != "undefined" ? opts.data.p : 1;
	var next_btn=typeof(opts.data.next_btn) != "undefined" ? opts.data.next_btn : '.tips';
	var cache_name = md5(opts.url + JSON.stringify(opts.data));
	var cache_data = plus.storage.getItem(cache_name);
	if(cache_data) {
		cache_data=JSON.parse(cache_data);
		if(typeof(opts.callback) == "function") {
			opts.callback(cache_data);
		}
	}
	mui.ajax(opts.url, {
		data: opts.data,
		dataType: "json",
		type: "post",
		timeout: 10000,
		success: function(data) {
			plus.storage.setItem(cache_name,JSON.stringify(data));
			if(typeof(opts.callback) == "function") {
				opts.callback(data);
			}
			if(scope.totalPage > scope.p && opts.cache !== false) {
				scope.p += 1;
				opts.data.p = scope.p;
				mui.ajax(opts.url, {
					data: opts.data,
					dataType: "json",
					type: "post",
					timeout: 10000,
					success: function(data) {
						if(typeof(opts.callback_next) == "function") {
							opts.callback_next(data);
						}
					},
					error: function(e) {
						console.log(JSON.stringify(e));
					}
				});
			}
		},
		error: function(e) {
			console.log(JSON.stringify(e));
		}
	});
	var next_page=function () {
		//一共就一页
		if(scope.totalPage==1) {
			return false;
		} else if(opts.cache !== false) {
			scope.$apply();
			if(scope.totalPage > scope.p) {
				scope.p += 1;
				opts.data.p = scope.p;
				mui.ajax(opts.url, {
					data: opts.data,
					dataType: "json",
					type: "post",
					timeout: 10000,
					success: function(data) {
						if(typeof(opts.callback_next) == "function") {
							opts.callback_next(data);
						}
					},
					error: function() {
						console.log(JSON.stringify(e));
					}
				});
			}
		} else if(scope.totalPage > scope.p) {
			scope.p += 1;
			opts.data.p = scope.p;
			mui.ajax(opts.url, {
				data: opts.data,
				dataType: "json",
				type: "post",
				timeout: 10000,
				success: function(data) {
					if(typeof(opts.callback_next) == "function") {
						opts.callback_next(data);
					}
				},
				error: function() {
					console.log(JSON.stringify(e));
				}
			});
		}
	}
	mui(document).on("tap",next_btn,function () {
		next_page();          
	});
	document.addEventListener('plusscrollbottom', function() {
		next_page();
	});
}


/**
 * 分享
 */
//(function() {
//	var plusReady = function(callback) {
//		if(window.plus) {
//			callback();
//		} else {
//			document.addEventListener('plusready', callback);
//		}
//	}
//	var shareServices = {};
//	var init = function() {
//		plus.share.getServices(function(services) {
//			for(var i = 0, len = services.length; i < len; i++) {
//				shareServices[services[i].id] = services[i];
//			}
//		});
//	};
//	var isWechatInstalled = function() {
//		return plus.runtime.isApplicationExist && plus.runtime.isApplicationExist({
//			pname: 'com.tencent.mm',
//			action: 'weixin://'
//		});
//	};
//
//	function share(id, msg, callback) {
//		var service = shareServices[id];
//		if(!service) {
//			callback && callback(false);
//			return;
//		}
//		var _share = function() {
//			service.send(msg, function() {
//				plus.nativeUI.toast("分享到\"" + service.description + "\"成功！");
//				callback && callback(true);
//			}, function(e) {
//				plus.nativeUI.toast("分享到\"" + service.description + "\"失败！");
//				callback && callback(false);
//			})
//		};
//		if(service.authenticated) {
//			_share(service, msg, callback);
//		} else {
//			service.authorize(function() {
//				_share(service, msg, callback);
//			}, function(e) {
//				console.log("认证授权失败");
//				callback && callback(false);
//			})
//		}
//	};
//
//	function openSystem(msg, callback) {
//		if(plus.share.sendWithSystem) {
//			plus.share.sendWithSystem(msg, function() {
//				//TODO 系统分享暂不支持回调
//				//callback && callback(true);
//			}, function() {
//				//TODO 系统分享暂不支持回调
//				//callback && callback(false);
//			});
//		} else {
//			callback && callback(false);
//		}
//	}
//	var open = function(msg, callback) {
//		/**
//		 *如下情况直接打开系统分享
//		 * 1、未配置微信分享通道
//		 * 2、用户手机未安装威胁你
//		 * 3、360浏览器下
//		 */
//
//		if(shareServices.weixin && isWechatInstalled() && !/360\sAphone/.test(navigator.userAgent)) {
//			plus.nativeUI.actionSheet({
//				title: '分享到',
//				cancel: "取消",
//				buttons: [{
//					title: "微信消息"
//				}, {
//					title: "微信朋友圈"
//				}, {
//					title: "更多分享"
//				}]
//			}, function(e) {
//				var index = e.index;
//				switch(index) {
//					case 1: //分享到微信好友
//						msg.extra = {
//							scene: 'WXSceneSession'
//						};
//						share('weixin', msg, callback);
//						break;
//					case 2: //分享到微信朋友圈
//						msg.title = msg.content;
//						msg.extra = {
//							scene: 'WXSceneTimeline'
//						};
//						share('weixin', msg, callback);
//						break;
//					case 3: //更多分享
//						var url = msg.href ? ('( ' + msg.href + ' )') : '';
//						msg.title = msg.title + url;
//						msg.content = msg.content + url;
//						openSystem(msg, callback);
//						break;
//				}
//			})
//		} else {
//			//系统分享
//			var url = msg.href ? ('( ' + msg.href + ' )') : '';
//			msg.title = msg.title + url;
//			msg.content = msg.content + url;
//			openSystem(msg, callback);
//		}
//	};
//	plusReady(init);
//	window.plusShare = open;
//})();

/**
 * 模仿PHP的strtotime()函数
 * strtotime('2012-07-27 12:43:43') OR strtotime('2012-07-27')
 * @return 时间戳
 */
function strtotime(str){
    var _arr = str.split(' ');
    var _day = _arr[0].split('-');
    _arr[1] = (_arr[1] == null) ? '0:0:0' :_arr[1];
    var _time = _arr[1].split(':');
    for (var i = _day.length - 1; i >= 0; i--) {
        _day[i] = isNaN(parseInt(_day[i])) ? 0 :parseInt(_day[i]);
    };
    for (var i = _time.length - 1; i >= 0; i--) {
        _time[i] = isNaN(parseInt(_time[i])) ? 0 :parseInt(_time[i]);
    };
    var _temp = new Date(_day[0],_day[1]-1,_day[2],_time[0],_time[1],_time[2]);
    return _temp.getTime() / 1000;
}


/**
 * 模仿PHP的date()函数
 * strtotime('Y-m-d H:i:s');
 * @param format 只支持 'Y-m-d H:i:s','Y-m-d','H:i:s' 三种调用方式
 * @param time 为空时，取当前时间
 * @return 日期格式化的字符串
 */
function date(format,time){
    var _temp = (time != null) ? new Date(time*1000) : new Date();
    var _return = '';

    if(/Y-m-d/.test(format)){
        var _day = [_temp.getFullYear(),addzero(1 + _temp.getMonth()),addzero(_temp.getDate())];
        _return = _day.join('-');
    }
    if(/H:i:s/.test(format)){
        var _time = [addzero(_temp.getHours()),addzero(_temp.getMinutes()),addzero(_temp.getSeconds())];
        _return += ' ' +_time.join(':');
    }
    return _return;
    function addzero(i){
        if(i<=9){
            return '0' + i;
        }else{
            return i;
        }
    }
}


/**
 * forward  前一页
 * id 窗口id
 */
function openwindow(){
	var opts = arguments[0];
	var url=typeof(opts.url)!="undefined"?opts.url:opts.id+'.html';
	var style=typeof(opts.style)!="undefined"?opts.style:{top:'0',bottom:'0',bounce:'none'};
	opts.id=opts.id=='index'?plus.runtime.appid:opts.id;
	opts.forward=typeof(opts.forward)!="undefined"?opts.forward:plus.webview.currentWebview().id;
	opts.animation=typeof(opts.animation)!="undefined"?opts.animation:'none';
	opts.data=typeof(opts.data)!="undefined"?opts.data:{};
	myStorage.setItem("forward",plus.webview.currentWebview().id);
	if (!plus.webview.getWebviewById(opts.id)) {
		plus.webview.create(url,opts.id,style,opts.data);
		setTimeout(function () {
			mui.fire(plus.webview.getWebviewById(opts.id), opts.id,opts.data); 
		},50);
	}else{
		plus.webview.hide(opts.id);
		mui.fire(plus.webview.getWebviewById(opts.id), opts.id,opts.data); 
	}
	setTimeout(function () {
		plus.webview.show(opts.id,opts.animation);
	},200);
}

/**
 * 设置头部颜色
 */
function headbg(style,bgcolor){
	plus.navigator.setStatusBarStyle(style);
	plus.navigator.setStatusBarBackground(bgcolor);
	var self = plus.webview.currentWebview();
	self.addEventListener('show',function () {
		plus.navigator.setStatusBarStyle(style);
		plus.navigator.setStatusBarBackground(bgcolor);
	});
}

mui(document).on("tap",".mui-action-back",function () {
    var the=jQuery(this);
    if (myStorage.getItem("forward")) {
    	var forward=myStorage.getItem("forward");
    	mui.fire(plus.webview.getWebviewById(forward), forward); 
    }
    mui.fire(plus.webview.getWebviewById(forward), 'back'); 
});
